Index: sources/app/src/main/java/parkup/services/RegisteredUserService.java
===================================================================
--- sources/app/src/main/java/parkup/services/RegisteredUserService.java	(revision 9dd526f0ddf9a23ad37dd4c977f761ff959f5913)
+++ sources/app/src/main/java/parkup/services/RegisteredUserService.java	(revision 9dd526f0ddf9a23ad37dd4c977f761ff959f5913)
@@ -0,0 +1,151 @@
+package parkup.services;
+
+import java.time.LocalDateTime;
+import java.util.List;
+import java.util.Objects;
+import java.util.Optional;
+import java.util.UUID;
+import javax.transaction.Transactional;
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.data.jpa.repository.Modifying;
+import org.springframework.security.core.userdetails.UserDetails;
+import org.springframework.security.core.userdetails.UserDetailsService;
+import org.springframework.security.core.userdetails.UsernameNotFoundException;
+import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
+import org.springframework.stereotype.Service;
+import parkup.configs.email.EmailValidator;
+import parkup.configs.token.ConfirmationTokenRP;
+import parkup.configs.token.ConfirmationTokenService;
+import parkup.data.Plate;
+import parkup.entities.RegisteredUser;
+import parkup.repositories.RegisteredUserRepository;
+
+@Service
+public class RegisteredUserService implements UserDetailsService {
+    private final RegisteredUserRepository registeredUserRepository;
+    private final BCryptPasswordEncoder bCryptPasswordEncoder;
+    private final ConfirmationTokenService confirmationTokenService;
+    private final EmailValidator emailValidator;
+    @Autowired
+    public RegisteredUserService(RegisteredUserRepository registeredUserRepository, BCryptPasswordEncoder bCryptPasswordEncoder, ConfirmationTokenService confirmationTokenService, EmailValidator emailValidator) {
+        this.registeredUserRepository = registeredUserRepository;
+        this.bCryptPasswordEncoder = bCryptPasswordEncoder;
+        this.confirmationTokenService = confirmationTokenService;
+        this.emailValidator = emailValidator;
+    }
+
+    public List<RegisteredUser> getRegPark() {
+        return this.registeredUserRepository.findAll();
+    }
+
+    public Optional<RegisteredUser> addRegPark(RegisteredUser regPark) {
+        Optional<RegisteredUser> regParkOpt = this.registeredUserRepository.findRegisteredUserByEmail(regPark.getEmail());
+        if (regParkOpt.isPresent()) {
+            throw new IllegalStateException("Email already taken, try adding a registriranParkirac with a different valid email address");
+        } else {
+            if (regPark.getEmail() != null && regPark.getEmail().length() > 1 && regPark.getEmail().contains("@")) {
+                this.registeredUserRepository.save(regPark);
+            }
+            else {
+                throw new IllegalStateException("email not valid");
+            }
+        }
+        return regParkOpt;
+    }
+
+    @Transactional
+    public RegisteredUser updateRegPark(int regParkId, String name, String surname, String mobile, String email, List<Plate> regTablicki) {
+        Optional<RegisteredUser> regParkOpt = Optional.ofNullable(this.registeredUserRepository.findByRegParkId(regParkId));
+        if (regParkOpt.isPresent()) {
+            RegisteredUser regParkNov = this.registeredUserRepository.findByRegParkId(regParkId);
+            if (email != null && email.length() > 1 && email.contains("@") && !Objects.equals(regParkNov.getEmail(), email)) {
+                Optional<RegisteredUser> userOpt1 = this.registeredUserRepository.findRegisteredUserByEmail(email);
+                if (userOpt1.isPresent()) {
+                    throw new IllegalStateException("email taken");
+                }
+
+                regParkNov.setEmail(email);
+            }
+
+            if (name != null && name.length() > 1 && !Objects.equals(regParkNov.getName(), name)) {
+                regParkNov.setName(name);
+            }
+
+            if (surname != null && surname.length() > 1 && !Objects.equals(regParkNov.getSurname(), surname)) {
+                regParkNov.setSurname(surname);
+            }
+
+            if (mobile != null && mobile.length() > 0 && !Objects.equals(regParkNov.getMobile(), mobile)) {
+                regParkNov.setMobile(mobile);
+            }
+            regParkNov.setPlates(regTablicki);
+            return regParkNov;
+        }else{
+            throw new IllegalStateException("RegistriranParkirac doesn't exist, therefore can't be updated");
+        }
+    }
+
+    @Transactional
+    @Modifying
+    public Optional<RegisteredUser> deleteRegPark(int regParkId) {
+        Optional<RegisteredUser> regPark = Optional.ofNullable(this.registeredUserRepository.findByRegParkId(regParkId));
+        if (regPark.isPresent()) {
+            //TODO da povikamo metod od ConfirmationTokenService za brisenje na ConfirmationTokenRP *DONE
+            //TODO da se izbrisat tablicki i da ne se dupliraat istite tablicki pri update ili add na nov registriranParkirac
+            this.confirmationTokenService.deleteByRegisteredUser_RegParkId(regParkId);
+            this.registeredUserRepository.deleteByRegParkId(regParkId);
+        } else {
+            throw new IllegalStateException("RegistriranParkirac doesn't exist, therefore can't be deleted");
+        }
+        return regPark;
+    }
+
+    public RegisteredUser findById(int regParkId) {
+        Optional<RegisteredUser> regPark = Optional.ofNullable(this.registeredUserRepository.findByRegParkId(regParkId));
+        return regPark.orElse(null);
+    }
+
+    @Override
+    public UserDetails loadUserByUsername(String email) throws UsernameNotFoundException {
+        return registeredUserRepository.findRegisteredUserByEmail(email)
+                .orElseThrow(() ->
+                        new UsernameNotFoundException("Email not found"));
+
+    }
+
+    public String signUpRegistriranParkirac(RegisteredUser registeredUser){
+        if (registeredUser.getEmail() == null || registeredUser.getEmail().isEmpty())
+            throw new IllegalArgumentException("Empty email");
+        if (!emailValidator.test(registeredUser.getEmail()))
+            throw new IllegalArgumentException("Invalid email");
+        boolean registriranParkiracExists = registeredUserRepository
+                .findRegisteredUserByEmail(registeredUser.getEmail())
+                .isPresent();
+        if(registriranParkiracExists){
+            throw new IllegalStateException("Email already taken");
+        }
+
+        String encodedPassword = bCryptPasswordEncoder
+                .encode(registeredUser.getPassword());
+
+        registeredUser.setPassword(encodedPassword);
+
+        registeredUserRepository.save(registeredUser);
+
+        String token = UUID.randomUUID().toString();
+        ConfirmationTokenRP confirmationTokenRP = new ConfirmationTokenRP(
+                token,
+                LocalDateTime.now(),
+                LocalDateTime.now().plusMinutes(15),
+                registeredUser
+        );
+
+        confirmationTokenService.saveConfirmationTokenRP(confirmationTokenRP);
+
+        return token;
+    }
+
+    public int enableRegistriranParkirac(String email) {
+        return registeredUserRepository.enableRegisteredUser(email);
+    }
+}
Index: sources/app/src/main/java/parkup/services/WorkerService.java
===================================================================
--- sources/app/src/main/java/parkup/services/WorkerService.java	(revision 9dd526f0ddf9a23ad37dd4c977f761ff959f5913)
+++ sources/app/src/main/java/parkup/services/WorkerService.java	(revision 9dd526f0ddf9a23ad37dd4c977f761ff959f5913)
@@ -0,0 +1,200 @@
+package parkup.services;
+
+import java.util.*;
+import java.util.stream.Collectors;
+import javax.transaction.Transactional;
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.security.core.userdetails.UserDetails;
+import org.springframework.security.core.userdetails.UserDetailsService;
+import org.springframework.security.core.userdetails.UsernameNotFoundException;
+import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
+import org.springframework.stereotype.Service;
+import parkup.data.WorkerDemoParkingZones;
+import parkup.data.enumarations.EmployeeStatus;
+import parkup.entities.ParkingZone;
+import parkup.entities.Worker;
+import parkup.repositories.ParkingZoneRepository;
+import parkup.repositories.WorkerRepository;
+import parkup.data.WorkerDemo;
+
+@Service
+public class WorkerService implements UserDetailsService {
+    private final WorkerRepository workerRepository;
+    private final ParkingZoneRepository parkingZoneRepository;
+    private final BCryptPasswordEncoder bCryptPasswordEncoder;
+
+    @Autowired
+    public WorkerService(WorkerRepository workerRepository, ParkingZoneRepository parkingZoneRepository, BCryptPasswordEncoder bCryptPasswordEncoder) {
+        this.workerRepository = workerRepository;
+        this.parkingZoneRepository = parkingZoneRepository;
+        this.bCryptPasswordEncoder = bCryptPasswordEncoder;
+    }
+
+    public List<Worker> getWorkers() {
+        return this.workerRepository.findAll();
+    }
+
+    public WorkerDemoParkingZones findById(int workerId) {
+        Worker worker = this.workerRepository.findByWorkerId(workerId);
+        WorkerDemoParkingZones workerToReturn = new WorkerDemoParkingZones(worker);
+        return workerToReturn;
+    }
+
+    public List<WorkerDemo> getAllVraboteniDemos() {
+        List<Worker> workers = this.workerRepository.findAll();
+        List<WorkerDemo> workerDemos = new ArrayList<>();
+        for (Worker v : workers){
+            WorkerDemo vd = new WorkerDemo(v.getWorkerId(),v.getFirstName(), v.getLastName(), v.getEmail());
+            workerDemos.add(vd);
+        }
+        return workerDemos;
+    }
+
+    public Optional<Worker> addWorker(String password, String confirmPass, boolean locked, String firstName, String lastName, String mobile, String email, EmployeeStatus status, List<String> parkingZones) {
+        Optional<Worker> workerOpt = this.workerRepository.findWorkerByEmail(email);
+        if (workerOpt.isPresent()){
+            throw new IllegalArgumentException("User with that mail already exists");
+        }
+        Worker workerToAdd =new Worker();
+        if (email != null && email.length() > 1 && email.contains("@") ) {
+            workerToAdd.setEmail(email);
+        } else {
+            throw new IllegalStateException("email not valid");
+        }
+        if(!password.isEmpty()&&password.equals(confirmPass)){
+            workerToAdd.setPassword(bCryptPasswordEncoder.encode(password));
+        }
+        workerToAdd.setLocked(locked);
+
+        if (firstName != null && firstName.length() > 1) {
+            workerToAdd.setFirstName(firstName);
+        }
+
+        if (lastName != null && lastName.length() > 1 ) {
+            workerToAdd.setLastName(lastName);
+        }
+
+        if (mobile != null && mobile.length() > 0 ) {
+            workerToAdd.setMobile(mobile);
+        }
+
+        workerToAdd.setStatus(status);
+
+        if(parkingZones!=null){
+            List<ParkingZone> parkingZonesAvailable =parkingZoneRepository.findAll();
+            List<ParkingZone> zonesToAdd= new ArrayList<>();
+            workerToAdd.setParkingZones(null);
+            for(String pzName:parkingZones){
+                for(ParkingZone pz :parkingZonesAvailable){
+                    if(pzName.equals(pz.getPzName())) {
+                        zonesToAdd.add(pz);
+//                            pz.getOdgovorniLica().add(vrabotenRepository.findByVrabotenId(vrabotenId));
+                    }
+                }
+            }
+            workerToAdd.setParkingZones(zonesToAdd);
+        }
+        workerRepository.save(workerToAdd);
+        return Optional.of(workerToAdd);
+    }
+
+    @Transactional
+    public WorkerDemoParkingZones updateWorker(int workerId, String password, String confirmPass, boolean locked, String firstName, String lastName, String mobile, String email, EmployeeStatus status, List<String> parkingZones) {
+        Optional<Worker> workerOpt = Optional.ofNullable(this.workerRepository.findByWorkerId(workerId));
+        if (workerOpt.isPresent()) {
+
+            if (email != null && email.length() > 1 && email.contains("@") ) {
+                List<String> emails = workerRepository.findAll().stream().map(Worker::getEmail).collect(Collectors.toList());
+                for(String mailToCheck :emails)
+                if (email.equals(mailToCheck)&&workerOpt.get().getWorkerId()!=workerId) {
+                    throw new IllegalStateException("email taken");
+                }
+                workerOpt.get().setEmail(email);
+            } else {
+                throw new IllegalStateException("email not valid");
+            }
+            if(!password.isEmpty()&&password.equals(confirmPass)){
+                workerOpt.get().setPassword(bCryptPasswordEncoder.encode(password));
+            }
+            workerOpt.get().setLocked(locked);
+
+            if (firstName != null && firstName.length() > 1 && !Objects.equals(workerOpt.get().getFirstName(), firstName)) {
+                workerOpt.get().setFirstName(firstName);
+            }
+
+            if (lastName != null && lastName.length() > 1 && !Objects.equals(workerOpt.get().getLastName(), lastName)) {
+                workerOpt.get().setLastName(lastName);
+            }
+
+            if (mobile != null && mobile.length() > 0 && !Objects.equals(workerOpt.get().getMobile(), mobile)) {
+                workerOpt.get().setMobile(mobile);
+            }
+
+//            if (status != null && status.toString().length() > 0) {
+//                if(Arrays.stream(EmployeeStatus.values()).toList().contains(EmployeeStatus.valueOf(status))){
+            workerOpt.get().setStatus(status);
+//                }else{
+//                    throw new IllegalStateException("Please enter one of the following statuses: 'raboti', 'ne raboti', 'na odmor', 'na boleduvanje'");
+//                }
+//            }
+            if(parkingZones!=null){
+                List<ParkingZone> parkingZonesAvailable =parkingZoneRepository.findAll();
+                List<ParkingZone> zonesToAdd= new ArrayList<>();
+                workerOpt.get().setParkingZones(null);
+                for(String pzName:parkingZones){
+                    for(ParkingZone pz :parkingZonesAvailable){
+                        if(pzName.equals(pz.getPzName())) {
+                            zonesToAdd.add(pz);
+//                            pz.getOdgovorniLica().add(vrabotenRepository.findByVrabotenId(workerId));
+                        }
+                    }
+                }
+                workerOpt.get().setParkingZones(zonesToAdd);
+            }
+//            VrabotenDemoParkingZones zoneToReturn = new VrabotenDemoParkingZones(workerOpt.get());
+            return new WorkerDemoParkingZones(workerOpt.get());
+        }
+        else{
+            throw new IllegalStateException("Worker doesn't exist, therefore can't be updated");
+        }
+    }//za menjanje password da se implementira
+
+    @Transactional
+    public Optional<Worker> deleteWorker(int workerId) {
+        Optional<Worker> workerOpt = Optional.ofNullable(this.workerRepository.findByWorkerId(workerId));
+        if (workerOpt.isPresent()) {
+            this.workerRepository.deleteByWorkerId(workerId);
+        } else {
+            throw new IllegalStateException("Worker doesn't exist, therefore can't be deleted");
+        }
+        return workerOpt;
+    }
+
+    @Transactional
+    public void lockWorkerAcc(int workerId) {
+        Worker workerOpt = this.workerRepository.findByWorkerId(workerId);
+        if (workerOpt !=null) {
+            workerOpt.lockVraboten();
+        } else {
+            throw new IllegalStateException("Worker doesn't exist, therefore his account can't be locked/unlocked");
+        }
+    }
+
+    @Override
+    public UserDetails loadUserByUsername(String email) throws UsernameNotFoundException {
+        return workerRepository.findWorkerByEmail(email)
+                .orElseThrow(() ->
+                        new UsernameNotFoundException("Email not found"));
+    }
+
+//    @Transactional
+//    public void setVrabotenStatus(int vrabotenId,String vrabotenStatus) {
+//        Vraboten vraboten = vrabotenRepository.findByVrabotenId(vrabotenId);
+//        if(vraboten!=null && value){
+//            vraboten.setStatus(valuee);
+//        }
+//        else {
+//            throw new IllegalStateException(String.format("Vraboten with id %d does not exist.",vrabotenId));
+//        }
+//    }
+}
